<?

# $Id: addsvc.php 758 2005-11-23 21:34:20Z raf $

require_once("../inc/autoexec.inc.php");
require_once("../inc/forms.inc.php");

$clid = (isset($_GET["clid"]) ? $_GET["clid"] : 0);
$clid = (isset($_POST["clid"]) ? $_POST["clid"] : $clid);
$oid = (isset($_GET["oid"]) ? $_GET["oid"] : 0);
$oid = (isset($_POST["oid"]) ? $_POST["oid"] : $oid);
$i4 = (isset($_GET["i4"]) ? $_GET["i4"] : 0);
$i4 = (isset($_POST["i4"]) ? $_POST["i4"] : $i4);
$i7 = (isset($_GET["i7"]) ? $_GET["i7"] : 0);
$i7 = (isset($_POST["i7"]) ? $_POST["i7"] : $i7);

$cki4 = "c" . md5("clid = $clid") . crc32("clid = $clid") . "a";
$cki7 = $i7 * 3600;

if ($cki4 != $i4) die("Unauthorized");
if ((time() - 3600) > $cki7)
	{
	header("Location: ../client/login.php?timeout=yes");
	exit;
	}

if (!strlen($clid)) diehard("Client ID# missing");
if (!is_numeric($clid)) diehard("Client ID#$clid not numeric");
if (ceil($clid) != $clid) diehard("Client ID#$clid is float");
if ($clid < 1) diehard("Client ID#$clid undefined");

$cl = new Client($clid);
if (!$cl->wasOK())
	diehard("Client ID#$clid ERROR: " . $cl->lastError());

if (!strlen($oid)) diehard("Order ID# missing");
if (!is_numeric($oid)) diehard("Order ID#$oid not numeric");
if (ceil($oid) != $oid) diehard("Order ID#$oid is float");
if ($oid == 0)
	{
	header("Location: ../client/special.php?clid=$clid&i4=$i4&i7=$i7");
	exit;
	}

if ($oid < 1) diehard("Order ID#$oid undefined");

$or = new Order($oid);
if (!$or->wasOK())
	diehard("Order ID#$oid ERROR: " . $or->lastError());

$ORDERTYPE = strtolower($or->descOrderType());
$ORDERTYPENAME = $or->descOrderTypeName();
$ORDERTYPENAMEUCW = ucwords($or->descOrderTypeName());

# make a resume order link

$ws = new Website($or->getWebsiteID());
if (!$ws->wasOK()) diehard("Order ID#$oid Website ID#" .
	$or->getWebsiteID() . " error: " . $ws->lastError());

$ORDER_A_RESUME_LINK = $CODEBASE . "/order/orderf.php?site=" .
	$ws->getWebname() . "&clear=";

# prices...

$pr = new Prices();

$prices = $pr->getPrices();
if (!$prices) diehard("getPrices: " . $p->lastError());

# see if we have special prices for this website

$altpr = $pr->setWebsiteID($or->getWebsiteID());
if ($altpr) # true -- has all the prices set; so change them
	{
	$prices = $pr->getPrices();
	if ($prices === false)
		diehard("Cannot get prices for order Website: " .
			$pr->lastError());
	}

foreach ($prices as $n => $v)
	{
	$var = "PRICE_$n";
	$$var = $v[0];
	}

# this should be included only after the prices are set

require_once("../client/addsvc-desc.php");

# script goes here

if ($or->hasAltPayment())
	{
	header("Location: ../client/olist.php?clid=$clid&i4=$i4&i7=$i7&msg=" .
		ADDSVC_ORDER_HAS_ALTPAYMENT . "&oid=$oid");
	exit;
	}

$as = new Assignment();
$asid = $as->getIDByOrderID($oid);
if (!$asid)
	{
	header("Location: ../client/olist.php?clid=$clid&i4=$i4&i7=$i7&msg=" .
		ADDSVC_ORDER_NOT_ASSIGNED . "&oid=$oid");
	exit;
	}

$as = new Assignment($asid);
#if (!$as->getCompleted()) diehard("Order ID#$oid is not completed yet");

if ($_SERVER["REQUEST_METHOD"] == "GET")
	{
/*
	echo "hasever Snail:"; var_dump($or->hasThisInRevisionChain("Snail"));
	echo "hasever Letter1:"; var_dump($or->hasThisInRevisionChain("Letter1"));
	echo "hasever CoverLetter:"; var_dump($or->hasThisInRevisionChain("CoverLetter"));
	echo "hasever JobHunter:"; var_dump($or->hasThisInRevisionChain("JobHunter"));
	echo "hasever HTMLService:"; var_dump($or->hasThisInRevisionChain("HTMLService"));
	echo "hasever ExtendedDl:"; var_dump($or->hasThisInRevisionChain("ExtendedDl"));
*/

	$frm_snail = $or->getSnail();
	$frm_jobhunter = $or->getJobhunter();
	$frm_l1 = $or->getLetter1();
	$frm_coverletter = $or->getCoverLetter();
	$frm_consult = $or->getConsult();	
	$frm_htmls = $or->getHTMLService();
	$frm_extdl = $or->getExtendedDl();
#	$frm_specialtxt = "";
	$frm_updaterequesttxt = "";

	$get = true;
	}
else
	{
	$get = false;

	$frm_snail = getcheckboxpostvar("frm_snail");
	$frm_jobhunter = getcheckboxpostvar("frm_jobhunter");
	$frm_l1 = getcheckboxpostvar("frm_l1");
	$frm_coverletter = getcheckboxpostvar("frm_coverletter");
	$frm_consult = getcheckboxpostvar("frm_consult");
	$frm_htmls = getcheckboxpostvar("frm_htmls");
	$frm_extdl = getcheckboxpostvar("frm_extdl");
#	$frm_specialtxt = getpostvar("frm_specialtxt");
	$frm_updaterequesttxt = "";
	}

# da form

$f = new Form("POST",$_SERVER["PHP_SELF"]);

$f->addInfoRow("Additional Services Request Order ID#$oid");

$f->addErrInfoRow("Errors in this form: %s");

$f->addHidden("clid",$clid);
$f->addHidden("oid",$oid);
$f->addHidden("i4",$i4);
$f->addHidden("i7",$i7);

$notavaliable = 0;

if ($or->getSnail() || $or->hasThisInRevisionChain("Snail"))
	{
	$f->addHidden("frm_snail",1);
	$notavaliable++;
	}
else
	{
	$f->addField("frm_snail","checkbox,1,0","Snail Mail
		service",$ADDSVCS["snail"]);
	$f->checkField();
	}


if ($or->getConsult() || $or->hasThisInRevisionChain("Consult")) {
	$f->addHidden("frm_consult",1);
	$notavaliable++;
} else {
	$f->addField("frm_consult","checkbox,1,0","Professional Coaching Service",$ADDSVCS["consult"]);
	$f->checkField();
}

	
if ($or->getOrderType() != ORDER_TYPE_COVERLETTER)
	{
	if ($or->getHTMLService() || $or->hasThisInRevisionChain("HTMLService"))
		{
		$f->addHidden("frm_htmls",1);
		$notavaliable++;
		}
	else
		{
		$f->addField("frm_htmls","checkbox,1,0","HTML
			service",$ADDSVCS["htmls"]);
		$f->checkField();
		}
	}
else
	{
	$f->addHidden("frm_htmls",0);
	$notavaliable++;
	}

if ($or->getJobHunter() || $or->hasThisInRevisionChain("JobHunter"))
	{
	$f->addHidden("frm_jobhunter",1);
	$notavaliable++;
	}
else
	{
	$f->addField("frm_jobhunter","checkbox,1,0","Jobhunter",$ADDSVCS["jh"]);
	$f->checkField();
	}

if ($or->getLetter1() || $or->hasThisInRevisionChain("Letter1"))
	{
	$f->addHidden("frm_l1",1);
	$notavaliable++;
	}
else
	{
	$f->addField("frm_l1","checkbox,1,0","Follow-up/Thank You
		letter",$ADDSVCS["l1"]);
	$f->checkField();
	}

if ($or->getOrderType() != ORDER_TYPE_COVERLETTER)
	{
	if ($or->getCoverLetter() || $or->hasThisInRevisionChain("CoverLetter"))
		{
		$f->addHidden("frm_coverletter",1);
		$notavaliable++;
		}
	else
		{
		$f->addField("frm_coverletter","checkbox,1,0","Cover
			letter",$ADDSVCS["cl"]);
		$f->checkField();
		}
	}
else
	{
	$f->addHidden("frm_coverletter",0);
	$notavaliable++;
	}

if ($or->getExtendedDl() || $or->hasThisInRevisionChain("ExtendedDl"))
	{
	$f->addHidden("frm_extdl",1);
	$notavaliable++;
	}
else
	{
	$f->addField("frm_extdl","checkbox,1,0","Extended Download
		service",$ADDSVCS["extdl"]);
	$f->checkField();
	}

# see if something was selected

$clicked = 0;

if (!$or->getSnail() &&
	!$or->hasThisInRevisionChain("Snail") && $frm_snail) $clicked++;
if (!$or->getJobHunter() &&
	!$or->hasThisInRevisionChain("JobHunter") && $frm_jobhunter)
	$clicked++;
if (!$or->getLetter1() &&
	!$or->hasThisInRevisionChain("Letter1") && $frm_l1) $clicked++;
if (!$or->getCoverLetter() &&
	!$or->hasThisInRevisionChain("CoverLetter") && $frm_coverletter)
	$clicked++;
if (!$or->getConsult() &&
	!$or->hasThisInRevisionChain("Consult") && $frm_consult)
	$clicked++;
if (!$or->getHTMLService() &&
	!$or->hasThisInRevisionChain("HTMLService") && $frm_htmls)
	$clicked++;
if (!$or->getExtendedDl() &&
	!$or->hasThisInRevisionChain("ExtendedDl") && $frm_extdl)
	$clicked++;

if ($notavaliable == 6 && $get) # no more services to add
	{
	header("Location: ../client/olist.php?clid=$clid&i4=$i4&i7=$i7&msg=" .
		NO_ADDSVC_AVALIABLE);
	exit;
	}

if (!$clicked && !strlen($frm_updaterequesttxt) && !$get)
	{
	header("Location: ../client/main.php?clid=$clid&i4=$i4&i7=$i7");
	exit;

/*
	$f->addErrInfoRow("PLEASE SELECT AT LEAST ONE SERVICE");
	$f->bumpErrors();
*/
	}

$f->addSubmit("  REQUEST  ");


$btxt = "  Forget it  ";
$bclick = "javascript:document.location = '../client/olist.php?clid=$clid&i4=$i4&i7=$i7';";
$f->addButton($btxt,$bclick);

# if there was an error while form post'ed or it's get display it

if (($f->numErr()) || $get)
        {
	normalPageStart();

	$UPDATELINK = "../client/update.php?oid=" . $or->GetID()
		. "&clid=$clid&i4=$i4&i7=$i7";

#        echo $f->dumpForm();
	require_once("forms/addsvc" . $or->descOrderTypeSuffix() . ".php");

	normalPageEnd();
	exit;
        }

$rv = new Revision();

$err = true;

while (1)
	{
	$ok = $rv->setOldOrderID($or->GetID());
	if (!$ok) break;
	$ok = $rv->setCardID(0);
	if (!$ok) break;
	$ok = $rv->setUpdateRequest(0);
	if (!$ok) break;
	$ok = $rv->setUpdateRequestTxt("");
	if (!$ok) break;
	$ok = $rv->Update();
	if (!$ok) break;

	$err = false;
	break;
	}

if ($err) diehard("Revision error: " . $rv->lastError());

/*
$co = new Comment();

$ok = $co->setOrderID($oid);
$ok = $co->setPoster("Customer");
$ok = $co->setComment(($rvgt == MSG_TYPE_WRITERDIRECT ?
	"Client\'s message to writer" : "Feedback from customer") . ":\n" .
	"--------------------------------\n" .
	"Subject: " . htmlentities($frm_subject) . "\n" .
	"--------------------------------\n" .
	nl2br(htmlentities($frm_comment)));
$ok = $co->Update();
*/

$moresvc = array();
$moresvc[] = (($or->getSnail() || $or->hasThisInRevisionChain("Snail")) ?
	false : $frm_snail);
$moresvc[] = (($or->getJobHunter() || $or->hasThisInRevisionChain("JobHunter")) ?
	false : $frm_jobhunter);
$moresvc[] = (($or->getLetter1() || $or->hasThisInRevisionChain("Letter1")) ?
	false : $frm_l1);
$moresvc[] = (($or->getCoverLetter() || $or->hasThisInRevisionChain("CoverLetter")) ?
	false : $frm_coverletter);
$moresvc[] = (($or->getConsult() || $or->hasThisInRevisionChain("Consult")) ?
	false : $frm_consult);
$moresvc[] = (($or->getHTMLService() || $or->hasThisInRevisionChain("HTMLService")) ?
	false : $frm_htmls);
$moresvc[] = (($or->getExtendedDl() || $or->hasThisInRevisionChain("ExtendedDl")) ?
	false : $frm_extdl);
$sermore = serialize($moresvc);
$sermoreck = md5("SERIALIZED:".$sermore);

header("Location: ../client/addsvc2.php?clid=$clid&oid=$oid&rv=" .
	$rv->getID() .
	"&i4=$i4&i7=$i7&sermore=$sermore&sermoreck=$sermoreck");

?>

