<?

# $Id: changes.php 753 2005-11-22 19:59:57Z raf $

require_once("../inc/autoexec.inc.php");
require_once("../inc/forms.inc.php");

$clid = (isset($_GET["clid"]) ? $_GET["clid"] : 0);
$clid = (isset($_POST["clid"]) ? $_POST["clid"] : $clid);
$oid = (isset($_GET["oid"]) ? $_GET["oid"] : 0);
$oid = (isset($_POST["oid"]) ? $_POST["oid"] : $oid);
$i4 = (isset($_GET["i4"]) ? $_GET["i4"] : 0);
$i4 = (isset($_POST["i4"]) ? $_POST["i4"] : $i4);
$i7 = (isset($_GET["i7"]) ? $_GET["i7"] : 0);
$i7 = (isset($_POST["i7"]) ? $_POST["i7"] : $i7);
$msgt = (isset($_GET["msgt"]) ? $_GET["msgt"] : MSG_TYPE_CHANGES);
$msgt = (isset($_POST["msgt"]) ? $_POST["msgt"] : $msgt);

$cki4 = "c" . md5("clid = $clid") . crc32("clid = $clid") . "a";
$cki7 = $i7 * 3600;

if ($cki4 != $i4) die("Unauthorized");
if ((time() - 3600) > $cki7)
	{
	header("Location: ../client/login.php?timeout=yes");
	exit;
	}

if (!strlen($clid)) diehard("Client ID# missing");
if (!is_numeric($clid)) diehard("Client ID#$clid not numeric");
if (ceil($clid) != $clid) diehard("Client ID#$clid is float");
if ($clid < 1) diehard("Client ID#$clid undefined");

$cl = new Client($clid);
if (!$cl->wasOK())
	diehard("Client ID#$clid ERROR: " . $cl->lastError());

if (!strlen($oid)) diehard("Order ID# missing");
if (!is_numeric($oid)) diehard("Order ID#$oid not numeric");
if (ceil($oid) != $oid) diehard("Order ID#$oid is float");
if ($oid < 0) diehard("Order ID#$oid undefined");

$ORDERTYPE = "resume order";
$ORDERTYPENAME = "resume";

while ($oid)
	{
	$or = new Order($oid);
	if (!$or->wasOK())
		diehard("Order ID#$oid ERROR: " . $or->lastError());

	$ORDERTYPE = strtolower($or->descOrderType());
	$ORDERTYPENAME = $or->descOrderTypeName();

	# script goes here

	$as = new Assignment();
	$asid = $as->getIDByOrderID($oid);
	if (!$asid)
		{
#		echo "not assigned";

		switch ($msgt)
			{
			case MSG_TYPE_SPECIALREQ:
				$msgt = MSG_TYPE_SPECIALREQNOWRITER;
				break;
			case MSG_TYPE_VOICEMAIL:
				break;
			default:
				$msgt = MSG_TYPE_NOWRITER;
				break;
			}

		break; # from while!
		}

	$as = new Assignment($asid);
	#if (!$as->getCompleted()) diehard("Order ID#$oid is not completed yet");

	$wid = $as->getWriterID();
	break;
	}

$ORDERTYPENAMEUC = strtoupper($ORDERTYPENAME);

if (!$oid)
	$msgt = MSG_TYPE_VOICEMAIL; # nor orderID it's a voicemail

$msgid = 0;

$ms = new Message($msgid);
if (!$ms->wasOK()) die("Message init error: " . $ms->lastError());

if ($_SERVER["REQUEST_METHOD"] == "GET")
	{
	$frm_subject = $ms->getSubject();
	$frm_comment = $ms->getComment();

	$get = true;
	}
else
	{
	$get = false;

	$frm_subject = getpostvar("frm_subject");
	$frm_comment = getpostvar("frm_comment");
	}

#

$ADDSVCSLINK = "addsvc.php?oid=$oid&clid=$clid&i4=$i4&i7=$i7";

# da form

$f = new Form("POST",$_SERVER["PHP_SELF"]);

$bye = "Thank you! We have received your message and will have a writer
	respond directly to your concerns within 2 business days.";
$form = "";

#echo "msgt=$msgt";

switch ($msgt)
	{
	case MSG_TYPE_CHANGES:

		$info = "Use this form to e-mail the writer with any changes
			& requests regarding order ID#$oid.<br>Please be
			polite, courteous, and succinct. Remember: Our
			writers are hard-working professionals who are most
			likely to respond favorably to clear, friendly
			words!";

		$left = "Describe your request";
		break;

	case MSG_TYPE_WRITERDIRECT:
		$left = "Comment";
		$info = "E-mail your questions or comments to our writer!";
		$bye = "Thank you! Your message has been sent directly to a
			writer who will review it, incorporate it into their
			work if applicable...and respond to you within 24-48
			business hours or sooner!";
		$form = "../client/forms/writermail.php";
		break;

	case MSG_TYPE_NOWRITER:

		$left = "Comment";
		$info = "E-mail your questions or comments to our writer!";
		$bye = "Thank you! Your message has been sent directly to a
			writer who will review it, incorporate it into their
			work if applicable...and respond to you within 24-48
			business hours or sooner!";
		$form = "../client/forms/writermail.php";
		$wid = 0;
		break;

	case MSG_TYPE_SPECIALREQ:
	case MSG_TYPE_SPECIALREQNOWRITER;
		$info = "If you would like to request a service that you do
			not see listed on our site, please describe it below
			and we will respond with a price quote within 3
			business days.";
		$left = "Describe your request";
		$wid = 0;
		$form = "../client/forms/specialrequest.php";
		break;

	case MSG_TYPE_VOICEMAIL:
		$info = "Your order is not ready yet. If you would like to
			request a service that you do not see listed on our
			site, please describe it below and we will respond
			with a price quote within 3 business days.";
		$left = "Describe your request";
		$wid = 0;
		$form = "../client/forms/specialrequest.php";
		break;

	default:
		$info = "E-mail your questions or comments to our writer!";
		$left = "Comment";
		break;
	}

$f->addInfoRow($info);

$f->addErrInfoRow("Errors in this form: %s");

$f->addHidden("clid",$clid);
$f->addHidden("oid",$oid);
$f->addHidden("i4",$i4);
$f->addHidden("i7",$i7);
$f->addHidden("msgt",$msgt);

if ($msgt == MSG_TYPE_SPECIALREQ)
	{
	$f->addHidden("frm_subject","Special request regarding OrderID#$oid");
	$frm_subject = "Special request regarding OrderID#$oid";
	}
else
	{
	$f->addField("frm_subject","string," . CONST_MSG_SUBJ_MINLEN .
		"," . CONST_MSG_SUBJ_MAXLEN . ",notnull,60","Subject");
	$f->checkField();
	}

$f->addField("frm_comment","textarea,60,20," . CONST_MSG_MAXLEN . ",notnull",
	$left);
$f->checkField();

$f->addSubmit("  SEND  ");
$btxt = "  Forget it  ";
$bclick = "javascript:document.location = '../client/olist.php?clid=$clid&i4=$i4&i7=$i7';";

$f->addButton($btxt,$bclick);

# if there was an error while form post'ed or it's get display it

if (($f->numErr()) || $get)
        {
	normalPageStart();

	$ORDERID = $oid;
	$SPECIALLINK = "../client/special.php?oid=$oid&clid=$clid&i4=$i4&i7=$i7";
	$UPDATELINK = "../client/update.php?oid=$oid&clid=$clid&i4=$i4&i7=$i7";
	$ADDSVCSLINK = "../client/addsvc.php?oid=$oid&clid=$clid&i4=$i4&i7=$i7";

	$FORM_ERROR = "";

	if (strlen($form) && $f->numErr())
		{
		$FORM_ERROR = "Please correct your form ";
		}

	if (!strlen($form))
		echo $f->dumpForm();
	else
		require_once($form);

	normalPageEnd();
	exit;
        }

$err = true;

while (1)
	{
	$ok = $ms->setMessageType($msgt);
	if (!$ok) break;
	$ok = $ms->setOrderID($oid);
	if (!$ok) break;
	$ok = $ms->setClid($clid);
	if (!$ok) break;
	$ok = $ms->setWriterID($wid);
	if (!$ok) break;
	$ok = $ms->setComment(htmlentities($frm_comment));
	if (!$ok) break;
	$ok = $ms->setSubject(htmlentities($frm_subject));
	if (!$ok) break;
	$ok = $ms->setReply("");
	if (!$ok) break;
	$ok = $ms->setReplydate(MSG_NOREPLY);
	if (!$ok) break;
	$ok = $ms->setWasRead(MSG_NOTREAD);
	if (!$ok) break;
	$ok = $ms->Update();
	if (!$ok) break;

	$err = false;
	break;
	}

if ($err) diehard("Message error: " . $ms->lastError());

if ($oid)
	{
	$co = new Comment();

	$ok = $co->setOrderID($oid);
	$ok = $co->setPoster("Customer");
	$ok = $co->setComment($ms->explainMessageType() . " from customer:\n" .
		"--------------------------------\n" .
		"Subject: " . htmlentities($frm_subject) . "\n" .
		"--------------------------------\n" .
		nl2br(htmlentities($frm_comment)));
	$ok = $co->Update();
	}

# send to Andy if it's special

if ($msgt == MSG_TYPE_SPECIALREQ && $msgt == MSG_TYPE_VOICEMAIL)
	{
	list($msg,$varinfo) = preparemessage(ADDSVCS_SPECIAL_LETTER);
	if ($msg === false) diehard("ADDSVCS_SPECIAL_LETTER failed: " .
		$varinfo);

	$ORDERID = $oid;
	$CLIENTNAME = $cl->getFirst() . " " . $cl->getLast();
	$CLIENTPHONE = $cl->getTlf();
	$CLIENTMAIL = $cl->getMail();

	$REQUESTMSG = $frm_comment;

	eval("\$frm_msg = \"" . addslashes($msg) . "\";");
	$frm_msg = stripslashes($frm_msg);

	$subj = sprintf(ADDSVCS_SPECIAL_LETTER_SUBJECT,$oid);
	$body = $frm_msg;

	list($body,$headers) = makefilemessage($CLIENTMAIL,ANDREWS_MAIL,
		$subj,$body);

	if ($body === false)
		diehard("Cannot make message: " . $headers);

	#echo "<pre>$headers"; exit;

	$m = mail(ANDREWS_MAIL,$subj,$body,$headers);

	if (!$m)
		diehard("Message sending failed");
	}

# header footer whatever

header("Location: ../client/olist.php?clid=$clid&i4=$i4&i7=$i7&msg=" .
	urlencode($bye));

?>

