<?

# $Id: grat.php 594 2004-07-30 18:44:32Z raf $

require_once("../inc/autoexec.inc.php");
require_once("../inc/forms.inc.php");

$clid = (isset($_GET["clid"]) ? $_GET["clid"] : 0);
$clid = (isset($_POST["clid"]) ? $_POST["clid"] : $clid);
$oid = (isset($_GET["oid"]) ? $_GET["oid"] : 0);
$oid = (isset($_POST["oid"]) ? $_POST["oid"] : $oid);
$i4 = (isset($_GET["i4"]) ? $_GET["i4"] : 0);
$i4 = (isset($_POST["i4"]) ? $_POST["i4"] : $i4);
$i7 = (isset($_GET["i7"]) ? $_GET["i7"] : 0);
$i7 = (isset($_POST["i7"]) ? $_POST["i7"] : $i7);

$cki4 = "c" . md5("clid = $clid") . crc32("clid = $clid") . "a";
$cki7 = $i7 * 3600;

if ($cki4 != $i4) die("Unauthorized");
if ((time() - 3600) > $cki7)
	{
	header("Location: ../client/login.php?timeout=yes");
	exit;
	}

if (!strlen($clid)) diehard("Client ID# missing");
if (!is_numeric($clid)) diehard("Client ID#$clid not numeric");
if (ceil($clid) != $clid) diehard("Client ID#$clid is float");
if ($clid < 1) diehard("Client ID#$clid undefined");

$cl = new Client($clid);
if (!$cl->wasOK())
	diehard("Client ID#$clid ERROR: " . $cl->lastError());

if (!strlen($oid)) diehard("Order ID# missing");
if (!is_numeric($oid)) diehard("Order ID#$oid not numeric");
if (ceil($oid) != $oid) diehard("Order ID#$oid is float");
if ($oid < 1) diehard("Order ID#$oid undefined");

$or = new Order($oid);
if (!$or->wasOK())
	diehard("Order ID#$oid ERROR: " . $or->lastError());

if ($or->hasAltPayment())
	{
	header("Location: ../client/olist.php?clid=$clid&i4=$i4&i7=$i7&msg=" .
		ADDSVC_ORDER_HAS_ALTPAYMENT . "&oid=$oid");
	exit;
	}

$caid = $or->getCardID();
$ci = new Card($caid);
if (!$ci->wasOK())
	diehard("Order ID#$oid Card ID#$caid error: " . $ci->lastError());

$as = new Assignment();
$asid = $as->getIDByOrderID($oid);
if (!$asid)
	diehard("Order ID#$oid has no assignment. This should never happen.");

$as = new Assignment($asid);
if (!$as->wasOK())
	diehard("Order ID#$oid Assignment ID#$asid error: " . $as->lastError());

if (!$as->getCompleted())
	diehard("Order ID#$oid is not completed yet. This should never happen.");

$wid = $as->getWriterID();
$wr = new Writer($wid);
if (!$wr->wasOK())
	diehard("Order ID#$oid Writer ID#$wid error: " . $wr->lastError());

$baselink = $_SERVER["PHP_SELF"] . "?oid=$oid&clid=$clid&i4=$i4&i7=$i7";
$forgetlink = "../client/olist.php?clid=$clid&i4=$i4&i7=$i7";

# da request type

if ($_SERVER["REQUEST_METHOD"] == "GET")
	{
	$frm_amnt = 15;
	$get = true;
	}
else
	{
	$get = false;

	$frm_amnt = getpostvar("frm_amnt");
	}

# da form

$f = new Form("POST",$_SERVER["PHP_SELF"]);

$f->addInfoRow("Writer Gratuities");

$f->addErrInfoRow("Errors in this form: %s");

$f->addHidden("clid",$clid);
$f->addHidden("oid",$oid);
$f->addHidden("i4",$i4);
$f->addHidden("i7",$i7);

$f->addField("frm_amnt","num,1,3","Amount");
$f->checkField("ck_amnt");

function ck_amnt($v)
	{
	if (!$v) return "Please type a number greater than 0";
	return "";
	}

$f->addSubmit("  CHARGE  ");

$btxt = "  Forget it  ";
$bclick = "javascript:document.location = '$forgetlink';";

$f->addButton($btxt,$bclick);

# if there was an error while form post'ed or it's get display it

if (($f->numErr()) || $get)
        {
#	normalPageStart();

#        echo $f->dumpForm();
	require_once("forms/grat.php");

#	normalPageEnd();
	exit;
        }

# CCAuth($oid,$cardid,$ccn,$ccexpm,$ccexpy,
#        $first,$last,$ad1,$ad2,$city,$state,$zip,
#        $phone,$country,$mail,$desc,$sale)

list($code,$explain) = CCAuth(
		$or->getID(),
		$ci->getID(),
		$ci->getNumber(),
		$ci->getMonth(),
		$ci->getYear(),
		$cl->getFirst(),
		$cl->getLast(),
		$cl->getAddr1(),
		$cl->getAddr2(),
		$cl->getCity(),
		$cl->getState(),
		$cl->getZip(),
		$cl->getTlf(),
		$cl->getCountry(),
		$cl->getMail(),
		CC_GRATUITY_DESCRIPTION,
		$frm_amnt,
		YOURPAY_OIDPREFIX . $or->getID() . "-GRAT-" . time()  
		);

#echo "charge=$code $explain";

$frm_amntfmt = sprintf("%.02f",$frm_amnt);

if ($code != "AUTH")
	{
	$co = new Comment();
	$ok = $co->setOrderID($oid);
	$ok = $co->setPoster(whoson());
	$ok = $co->setComment("Client tried to make gratuity to a writer but charge for \$$frm_amntfmt failed: $explain");
	$ok = $co->Update();

	header("Location: ../client/olist.php?clid=$clid&i4=$i4&i7=$i7&msg=" .
		GRATUITY_CHARGE_FAILED . "&oid=$oid");
	exit;
	}

$co = new Comment();
$ok = $co->setOrderID($oid);
$ok = $co->setPoster("client");
$ok = $co->setComment("Paid a gratuity of \$$frm_amntfmt.");
$ok = $co->Update();

# echo to writer

$GRATUITY = floor($frm_amnt / 100 * 80);
$ORDERID = $or->getID();
$CLIENTNAME = $cl->getFirst() . " " . $cl->getLast();
$CLIENTADDRESS = $cl->getAddr1() . "\n" . $cl->getAddr2();
$CLIENTADDRESS2 = $cl->getCity() . ", " . $cl->getState() . " " . $cl->getZip();
$CLIENTPHONE = $cl->getTlf();
$CLIENTMAIL = $cl->getMail();
$WRITERNAME = $wr->getName();
$CCLINK = $CODEBASE . "/client/";
$CCLINK = FixCCLINK($CCLINK); //CLC 3/3/09 In resconf.php 
$CCPASS = $cl->getPass();
$RESLINK = $CODEBASE . "/client/retresume.php?oid=" . $or->getID() .
	"&ck=" . md5("Order ID#" . $or->getID() . " retrieval") .
	"&asid=" . $as->getID();

# receipt to writer

list($message,$varinfo) = preparemessage(GRATUITY_WRITER_LETTER);
if ($message === false) diehard("GRATUITY_WRITER_LETTER message prepare failed: " .
	$varinfo);
eval("\$message = \"" . addslashes($message) . "\";");
$message = stripslashes($message);

$to = $wr->getEMail();
$subj = GRATUITY_WRITER_LETTER_SUBJECT;
$body = $message;

$FROM = ANDREWS_MAIL;
list($body,$headers) = makefilemessage($FROM,
	$to,$subj,$body);

if ($body === false)
	diehard("Cannot make client GRATUITY_WRITER_LETTER message: " . $headers);

$headers .= "\nBcc: " . ANDREWS_MAIL;

$m = mail($to,$subj,$body,$headers); 
if (!$m)
        diehard("Client message GRATUITY_WRITER_LETTER sending failed");

require_once("forms/gratok.php");

?>

