<?

# $Id: oinfo.php 753 2005-11-22 19:59:57Z raf $

require_once("../inc/autoexec.inc.php");
require_once("../inc/forms.inc.php");

$colspan = 3;

$clid = (isset($_GET["clid"]) ? $_GET["clid"] : 0);
$clid = (isset($_POST["clid"]) ? $_POST["clid"] : $clid);
$i4 = (isset($_GET["i4"]) ? $_GET["i4"] : 0);
$i4 = (isset($_POST["i4"]) ? $_POST["i4"] : $i4);
$i7 = (isset($_GET["i7"]) ? $_GET["i7"] : 0);
$i7 = (isset($_POST["i7"]) ? $_POST["i7"] : $i7);
$s = (isset($_GET["s"]) ? $_GET["s"] : 0);
$s = (isset($_POST["s"]) ? $_POST["s"] : $s);
$msg = (isset($_GET["msg"]) ? $_GET["msg"] : "");

$cki4 = "c" . md5("clid = $clid") . crc32("clid = $clid") . "a";
$cki7 = $i7 * 3600;

if ($cki4 != $i4) die("Unauthorized");
if ((time() - 3600) > $cki7)
	{
	header("Location: ../client/login.php?timeout=yes");
	exit;
	}

if (!strlen($clid)) diehard("Client ID# missing");
if (!is_numeric($clid)) diehard("Client ID#$clid not numeric");
if (ceil($clid) != $clid) diehard("Client ID#$clid is float");
if ($clid < 1) diehard("Client ID#$clid undefined");

$cl = new Client($clid);
if (!$cl->wasOK())
	diehard("Client ID#$clid ERROR: " . $cl->lastError());

$oid = (isset($_GET["oid"]) ? $_GET["oid"] : "");

# oid checks, it comes as id= in the get request

if (!strlen($oid)) diehard("Order ID# missing");
if (!is_numeric($oid)) diehard("Order ID#$oid not numeric");
if (ceil($oid) != $oid) diehard("Order ID#$oid is float");
if ($oid < 1) diehard("Order ID#$oid less than 1");

# now it's time to initialize classes, every error fails hard

$or = new Order($oid);
if (!$or->wasOK()) diehard("Order ID#$oid ERROR: " . $or->lastError());

$frm_otype = $or->descOrderType();

$clid = $or->getClid();
$cl = new Client($clid);
if (!$cl->wasOK()) diehard("Order ID#$oid Cliend ID#$clid ERROR: " .
	$cl->lastError());

$ri = new ResInfo();
$rid = $ri->getIDByOrderID($oid);
if (!$rid) diehard("Order ID#$oid Resume Info missing");

$ri = new ResInfo($rid);
if (!$ri->wasOK()) diehard("Order ID#$oid Resume Info ID#$rid ERROR: " .
	$ri->lastError());

$fi = new ResFile();
$fid = $fi->getIDByOrderID($oid);
if ($fid)
	{
	$fi = new ResFile($fid);
	if (!$fi->wasOK()) diehard("Order ID#$oid Resume File ID#$fid ERROR: " .
		$fi->lastError());
	}

$as = new Assignment();
$asid = $as->getIDByOrderID($oid);
$as = new Assignment($asid);
if (!$as->wasOK())
	diehard("Order ID#$oid Assignment ID#$asid error: " .
		$as->lastError());

$frm_deadline = $as->getDeadlineText();
$frm_assignedon = date(DATEFMT,$as->getChanged());
$frm_completed = $as->getCompleted();
if ($frm_completed)
	$frm_completed = date(DATEFMT,$frm_completed);

$co = new Comment();
$coids = $co->listByOrderID($oid);

# ok now initialize constant input fields and gather some pre-change order
# data

$frm_created = date(DATEFMT,$or->getCreated());

$frm_clname = $cl->getFirst() . " " . $cl->getLast() .
	" &lt;<a href=\"mailto:" . $cl->getMail() . "\">" .
	$cl->getMail() . "</a>&gt;";

$frm_riobj = nl2br($ri->getObjective());
$frm_riedu = nl2br($ri->getEducation());
$frm_riexp = nl2br($ri->getExperience());
$frm_riact = nl2br($ri->getActivities());
$frm_rimsc = nl2br($ri->getMisc());
$frm_ritype = $ri->getRestype();
switch ($frm_ritype)
	{
	case "f": $frm_ritype = "Functional"; break;
	case "c": $frm_ritype = "Chronological"; break;
	case "n": $frm_ritype = "Not sure"; break;
	default: $frm_ritype = "Unknown ($frm_ritype)"; break;
	}

if (!strlen($frm_riobj)) $frm_riobj = "* EMPTY *";
if (!strlen($frm_riedu)) $frm_riedu = "* EMPTY *";
if (!strlen($frm_riexp)) $frm_riexp = "* EMPTY *";
if (!strlen($frm_riact)) $frm_riact = "* EMPTY *";
if (!strlen($frm_rimsc)) $frm_rimsc = "* EMPTY *";

$frm_whatever = $oid;

$frm_snail = $or->getSnail();
$frm_jobhunter = $or->getJobhunter();
$frm_coverl = $or->getCoverLetter();
$frm_l1 = $or->getLetter1();
$frm_cons = $or->getConsult();
$frm_htmls = $or->getHTMLService();
$frm_ed = $or->getExtendedDl();

# here we should do something when the price has to change due to order data
# editing

# navigation

$back = "../client/olist.php?clid=$clid&i4=$i4&i7=$i7";
$ck = md5("Order ID#$oid retrieval"); 
$send = "../client/retresume2.php?clid=$clid&asid=$asid&oid=$oid&ck=$ck&i4=$i4&i7=$i7";

# generate the form

$f = new Form("POST",$_SERVER["PHP_SELF"]);

$f->addInfoRow((isset($_GET["msg"]) ? $_GET["msg"] :
	"Order ID#$oid record"));

if ($or->isRevision())
	{
	$rv = new Revision();
	$rvids = $rv->getIDByOrderID($oid);
	if (count($rvids) != 1)
		diehard("Order ID#$oid is a revision but rvids is (" .
			join(",",$rvids) . ")");
	$rvid = $rvids[0];
	$rv = new Revision($rvid);
	if (!$rv->wasOK())
		diehard("Order ID#$oid Revision ID#$rvid error: " .
			$rv->lastError());

	$rvoid = $rv->getOldOrderID();
	$rvlink = "<a href=\"" . $_SERVER["PHP_SELF"] .
		"?oid=$rvoid&clid=$clid&i4=$i4&i7=$i7&ck=$ck\">";
		
	$f->addInfoRow("NOTE: This is a revision of Order ID#" .
		"$rvlink$rvoid</a>. Click " . $rvlink . "HERE</a>
		to view the original order.");
	}

$f->addField("frm_whatever","static","Order ID#");
$f->makeDisabled();
$f->addField("frm_otype","static","Order Type");
$f->makeDisabled();
$f->addField("frm_created","static","Created");
$f->makeDisabled();

/*
$f->addInfoRow("Assignment options");

$f->addField("frm_assignedon","static","Assigned on");
$f->makeDisabled();

$f->addField("frm_deadline","static","Writer's Deadline");
$f->makeDisabled();
	
if ($frm_completed)
	{
	$f->addField("frm_completed","static","Completed");
	$f->makeDisabled();
	}

$f->addInfoRow("Client information");

$f->addField("frm_clname","static","Client info");
$f->makeDisabled();
*/

$f->addInfoRow("Resume file");
if (!$fid) 
	{
	$frm_upfile = "Youd did not upload a file";
	$sendfile = "";
	}
else
	{
	$frm_upfile = $fi->getFilename();
	$sendfile = "<a href=\"../admin/sendf.php?fid=$fid\">CLICK TO VIEW
		THE FILE YOU ORIGINALLY SENT</a>";
	}

$f->addField("frm_upfile","static","File",$sendfile);
$f->makeDisabled();

$f->addInfoRow("Resume info");

$f->addField("frm_snail","checkbox,1,0","Snail Mail service",
	($or->hasThisInRevisionChain("Snail") ?
	"(requested in revision(s))" : ""));
$f->addField("frm_jobhunter","checkbox,1,0","Jobhunter",
	($or->hasThisInRevisionChain("JobHunter") ?
	"(requested in revision(s))" : ""));
$f->addField("frm_coverl","checkbox,1,0","Cover Letter",
	($or->hasThisInRevisionChain("CoverLetter") ?
	"(requested in revision(s))" : ""));
$f->addField("frm_l1","checkbox,1,0","Follow-up/Thank You letter",
	($or->hasThisInRevisionChain("Letter1") ?
	"(requested in revision(s))" : ""));
$f->addField("frm_cons","checkbox,1,0","Professional Coaching Service",
	($or->hasThisInRevisionChain("CoachingService") ?
	"(requested in revision(s))" : ""));
$f->addField("frm_htmls","checkbox,1,0","HTML Service",
	($or->hasThisInRevisionChain("HTMLService") ?
	"(requested in revision(s))" : ""));
$f->addField("frm_extdl","checkbox,1,0","Extended Download Service",
	($or->hasThisInRevisionChain("ExtendedDl") ?
	"(requested in revision(s))" : ""));

$hs = new HTMLFile();
$hsid = $hs->getIDByOrderID($oid);
while ($hsid)
	{
	$hs = new HTMLFile($hsid[0]);
	if (!$hs->wasOK()) break;
	$f->addButton("Show HTML version of your resume",
		"javascript:window.open('" . $hs->getURL() .
		"');");
	break;
	}


/*
$f->addField("frm_ritype","static","Resume type");
$f->makeDisabled();
*/
$f->addField("frm_riobj","static","Objective");
$f->makeDisabled();
$f->addField("frm_riedu","static","Education");
$f->makeDisabled();
$f->addField("frm_riexp","static","Experience");
$f->makeDisabled();
$f->addField("frm_riact","static","Activities");
$f->makeDisabled();
$f->addField("frm_rimsc","static","Misc");
$f->makeDisabled();

$what = sprintf("  RE-SEND %s IF ALREADY COMPLETED  |",
	strtoupper($or->descOrderTypeName()));

$f->addButton((!$frm_completed ? "" : $what) . "  Back To Order List  ",
	(!$frm_completed ? "" : "javascript:document.location = '$send';|") .
		"javascript:document.location = '$back'");

clientPageStart();

echo $f->dumpForm();

clientPageEnd();

?>
