<?

# $Id: olist.php 804 2005-12-01 19:31:34Z raf $

require_once("../inc/autoexec.inc.php");

$clid = (isset($_GET["clid"]) ? $_GET["clid"] : 0);
$clid = (isset($_POST["clid"]) ? $_POST["clid"] : $clid);
$i4 = (isset($_GET["i4"]) ? $_GET["i4"] : 0);
$i4 = (isset($_POST["i4"]) ? $_POST["i4"] : $i4);
$i7 = (isset($_GET["i7"]) ? $_GET["i7"] : 0);
$i7 = (isset($_POST["i7"]) ? $_POST["i7"] : $i7);
$s = (isset($_GET["s"]) ? $_GET["s"] : 0);
$s = (isset($_POST["s"]) ? $_POST["s"] : $s);
$msg = (isset($_GET["msg"]) ? $_GET["msg"] : "");

$cki4 = "c" . md5("clid = $clid") . crc32("clid = $clid") . "a";
$cki7 = $i7 * 3600;

if ($cki4 != $i4) die("Unauthorized");
if ((time() - 3600) > $cki7)
	{
	header("Location: ../client/login.php?timeout=yes");
	exit;
	}

if (!strlen($clid)) diehard("Client ID# missing");
if (!is_numeric($clid)) diehard("Client ID#$clid not numeric");
if (ceil($clid) != $clid) diehard("Client ID#$clid is float");
if ($clid < 1) diehard("Client ID#$clid undefined");

$cl = new Client($clid);
if (!$cl->wasOK())
	diehard("Client ID#$clid ERROR: " . $cl->lastError());

clientPageStart();

$colspan = 5;

if (isset($_GET["msg"]))
	{
	$msg = $_GET["msg"];

	if ($msg == ADDSVC_ORDER_HAS_ALTPAYMENT)
		$msg = "Your order cannot be processed because it was not
			paid with a credit card";

	if ($msg == ADDSVC_ORDER_NOT_ASSIGNED)
		$msg = "Your order has not been assigned to a writer yet. Most of the
			options are unavailable until the order is assigned. 
			Orders are usually assigned within less than 12
			hours of order placement.  Please check this section
			at a later time.";

	if ($msg == ADDSVC_ORDER_NOT_COMPLETED)
		$msg = "Your order has not been completed yet.";

	if ($msg == GRATUITY_CHARGE_FAILED)
		$msg = "Your gratuity charge failed.";

	if ($msg == NO_ADDSVC_AVALIABLE)
		$msg = "There are no additional services avaliable for your
			order.";

	echo showmsg($msg);
	}

$nav = "<a class=\"d\" href=\"../client/login.php?logout=yes\">Logout</a>";

tabstart("Your Orders",array("ID#","Type","Created","Status","&nbsp;"),
	$colspan,$nav);

$duepayments = array();
$duetotal = 0;

$or = new Order();

$orders = $or->getIDByClientID($clid);

$i = 0;

foreach ($orders as $o)
	{
	$or = new Order($o);
	if (!$or->wasOK())
		{
		echo "<tr><td colspan=\"", $colspan, "\"
			class=\"tr$i\" align=\"left\">ORDER ID#$o ERROR: ",
			$or->lastError(), "</td></tr>\n";
		continue;
		}

#	if ($or->isRevision()) continue;

	echo "<tr>";

	echo "<td class=\"tr$i\" align=\"center\"><a
		href=\"oinfo.php?oid=$o&clid=$clid&i4=$i4&i7=$i7\">$o";
	echo ($or->isRevision() ? "R" : ""), "</a></td>\n";

	$status = "ORDER IN PROGRESS";

	if ($or->hasAltPayment())
		{
		$ap = new AltPayment();
		$apid = $ap->getIDByOrderID($or->getID());

		if (!$apid)
			{
			echo "<td colspan=\"", ($colspan-1), "\"
				class=\"tr$i\" align=\"left\">ALTPAYMENT
				MISMATCH</td></tr>\n";
			continue;

			}

		$ap = new AltPayment($apid);

		if (!$ap->wasOK())
			{
			echo "<tr><td colspan=\"", $colspan, "\"
				class=\"tr$i\" align=\"left\">ALTPAYMENT
				ID#$apid ERROR: " . $ap->lastError() .
				"</td></tr>\n";
			continue;
			}

		if (!$ap->getReceived())
			{
			$status = "Order Pending/Waiting for
				Payment<br><a
				href=\"../client/payment.php?oid=" .
				$or->getID() .
				"&clid=$clid&i4=$i4&i7=$i7\">CLICK
				HERE TO CHANGE PAYMENT TO CREDIT CARD</a>";
			$duepayments[] = $or->getID();
			$duetotal = $duetotal + $or->getSale();
			}
		}


	$as = new Assignment();
	$asid = $as->getIDByOrderID($o);
	if ($asid)
		{
		$as = new Assignment($asid);
		if (!$as->wasOK())
			{
			echo "<tr><td colspan=\"", ($colspan-1), "\"
				class=\"tr$i\" align=\"left\">ASSIGNMENT
				ERROR: ", $as->lastError(), "</td></tr>\n";
			continue;
			}

		$oid = $or->getID();
		$ck = md5("Order ID#$oid retrieval"); 
		$retrlink = "../client/retresume2.php?clid=$clid&asid=$asid&oid=$oid&i4=$i4&i7=$i7&ck=$ck";

		$status = "ASSIGNED SUCCESSFULLY/<br>ORDER IN PROGRESS";

		if ($as->getCompleted())
			$status = "ORDER COMPLETED AND SENT<br>" .
				date(DATEFMT_WITH_DAYNAME,$as->getCompleted()) .
				"<br><a href=\"$retrlink\">CLICK HERE TO
				DOWNLOAD YOUR NEW " .
				strtoupper($or->descOrderTypeName()) . "</a>";
		}
	else # no assignment, check if it's revision
		{
		while ($or->isRevision())
			{
			# it's a assignmentless revision so it means HTML or
			# Snail; check if completed and if so -- show it

			$markcompleted = 0;
			if ($or->getHTMLService())
				{
#				echo "HTML ";
				$markcompleted++;
				}
			if ($or->getSnail())
				{
#				echo "SNAIL ";
				$markcompleted++;
				}

			$datecompleted = 0;

			$rv = new Revision();
			$parent = $rv->getParentOrderID($or->getID());

			if (!$parent)
				{
				$status = "REVISION ERROR: parent for this
					order is 0!";
				break;
				}

#			echo "revision " . $or->getID() . " parent=$parent
#				markcompleted: $markcompleted<br>";

			while ($or->getHTMLService())
				{
				$hs = new HTMLFile();
				$hsid = $hs->getIDByOrderID($parent);
				if (!$hsid) break;

#				echo "hsid=$hsid<br>";

				$hs = new HTMLFile($hsid);
				if (!$hs->wasOK()) break;

				$markcompleted--;
				$datecompleted = $hs->getCreated();

#				echo "markcompleted: $markcompleted<br>";
#				echo "datecompleted: $datecompleted<br>";

				break;
				}

			while ($or->getSnail())
				{
				$q = "SELECT UNIX_TIMESTAMP(created)
					FROM hideit WHERE orderid = " .
					$or->getID() .
					" AND hidewhat LIKE '%snail%'
					LIMIT 0,1";
				$got = $db->query($q);

				# don't worry about complete date
				# snail is ALWAYS completed after HTML
				if ($got->numRows())
					{
					$datecompleted = $got->f(0);
					$markcompleted--;
					}

#				echo "markcompleted: $markcompleted<br>";
#				echo "datecompleted: $datecompleted<br>";

				break;
				}

			if (!$markcompleted) # services done
				{
				$status = "REVISION REQUEST COMPLETED<br>" .
				date(DATEFMT_WITH_DAYNAME,$datecompleted);
				}				

			break;
			}
		}

	echo "<td class=\"tr$i\" style=\"border-left: 1px dotted chocolate\"
		align=\"left\">";
	echo $or->descOrderType();
	echo "</td>\n";

	echo "<td class=\"tr$i\" style=\"border-left: 1px dotted chocolate\"
		align=\"left\">";
	echo date(DATEFMT,$or->getCreated());
	echo "</td>\n";

	echo "<td class=\"tr$i\" style=\"border-left: 1px dotted chocolate\"
		align=\"left\">$status</a></td></tr>\n";

	$i++;
	$i %= 2;
	}

if (!count($orders))
	tabrowinf("NO ORDERS",$colspan);
else
	tabrownav($nav,$colspan,BOTTOM_NAV);
	
echo "</table>";


if (count($duepayments))
	{
	$mm = "<br>To complete your order, please send your check or money order
		made out to Azoos.Com, Inc. for $" .
		sprintf("%.02f",$duetotal) . ".<br><br>";

	$se = new Settings();

	$settings = $se->getSettings();
	if (!$settings) diehard("getSettings: " . $p->lastError());

	foreach ($settings as $n => $v)
		{
		$var = "SETTING_$n";
		$$var = $v[0];
		}

	$mm .= "Our mailing address is:<br>$SETTING_CHECK_SENDTO_ADDRESS1
		<br>$SETTING_CHECK_SENDTO_ADDRESS2";

	$mm .= "<br><br>*Reference order(s) #" . join($duepayments,", #") .
		" on your payment!<br>We look forward to assisting you!";

	echo showmsg($mm);
	}


clientPageEnd();
 
?>
