<?

# $Id: retresume2.php 753 2005-11-22 19:59:57Z raf $

require_once("../inc/autoexec.inc.php");
require_once("../inc/forms.inc.php");

if (!isset($_GET["asid"])) diehard("Assignment ID# missing in request");
if (!isset($_GET["oid"])) diehard("Order ID# missing in request");
if (!isset($_GET["ck"])) diehard("CK missing in request");

$send = (isset($_GET["send"]) ? $_GET["send"] : "");

$asid = $_GET["asid"];
$oid = $_GET["oid"];
$ck = $_GET["ck"];

$i4 = (isset($_GET["i4"]) ? $_GET["i4"] : 0);
$i7 = (isset($_GET["i7"]) ? $_GET["i7"] : 0);
$clid = (isset($_GET["clid"]) ? $_GET["clid"] : 0);

if ($ck != md5("Order ID#$oid retrieval"))
	diehard("UNAUTHORIZED ACCESS");

if (!strlen($asid)) diehard("Assignment ID# missing");
if (!is_numeric($asid)) diehard("Assignment ID#$asid not numeric");
if (ceil($asid) != $asid) diehard("Assignment ID#$asid is float");
if ($asid < 1)
	{
	if (!$i4)
		diehard("Assignment ID#$asid less than 1");
	else
		header("Location: ../client/noresume.php&oid=$oid&clid=$clid&i4=$i4&i7=$i7");
	exit;
	}

$cl = new Client($clid);
if (!$cl->wasOK())
	diehard("Client ID#$clid error: " . $cl->lastError());

$CLIENTNAME = $cl->getFirst() . " " . $cl->getLast() . "'s";
if ($CLIENTNAME == " 's") $CLIENTNAME = "Your";

$as = new Assignment($asid);
if (!$as->wasOK()) diehard("Assignment ID#$asid ERROR: " . $or->lastError());

if (!$as->getCompleted())
	{
	if ($i4)
		{
		header("Location: ../client/noresume.php&oid=$oid&clid=$clid&i4=$i4&i7=$i7");
		exit;
		}

	$f = new Form("POST",$_SERVER["PHP_SELF"]);

	$f->addInfoRow("Your new resume has not yet been completed.
		Once it is finished, you will be able to access it via
		this link.");

	clientPageStart();
	echo $f->dumpForm();
	clientPageEnd();
	exit;
	}

if ($as->getOrderID() != $oid) diehard("Order ID#$oid does not match assignment");

$or = new Order($as->getOrderID());
if (!$or->wasOK()) diehard("Order ID#$oid ERROR: " . $or->lastError());

$ORDERTYPE = strtolower($or->descOrderType());
$ORDERTYPENAME = $or->descOrderTypeName();
$ORDERTYPENAMEUC = strtoupper($or->descOrderTypeName());

$file = "";

switch ($send)
	{
	case "r":
		$file = $as->getFilename();
		//$fn = COMPLETEDFILESDIR . "/" . $as->getDiskfilename();
    $fn = "http://secure.azoos.com/resume/completedresumefiles/" . $as->getDiskfilename();
		break;
	case "j";
		$file = $as->getJHFilename();
		$fn = COMPLETEDFILESDIR . "/" . $as->getJHDiskfilename();
    $fn = "http://secure.azoos.com/resume/completedresumefiles/" . $as->getJHDiskfilename();
		break;
	}


function file_exists_new($file)
{
  $headers = get_headers($file, 1);
  return stristr($headers[0], '200');
}

if (strlen($file))
	{
	if (!file_exists_new($fn))
		diehard("File is no longer avaliable on disk ($file)");

    /*
	if (!is_readable($fn))
		diehard("File unreadable ($file)");
    */

	$f = fopen($fn,"r");

	if (!$f)
		diehard("File cannot be opened: $file");

	header("Content-Type: application/octet-stream");
	header("Content-Disposition: attachment; filename=\"$file\"");
	header("Content-Description: file");

	while (!feof($f))
		{
		$buff = fread($f,4096);
		print $buff;
		}

	fclose($f);
	exit;
	}

$sendr = $_SERVER["PHP_SELF"] . "?asid=$asid&ck=$ck&oid=$oid&send=r";
$sendjh = $_SERVER["PHP_SELF"] . "?asid=$asid&ck=$ck&oid=$oid&send=j";

$isjh = $or->getJobhunter();

/*
$f = new Form("POST",$_SERVER["PHP_SELF"]);

$f->addInfoRow("Order ID#$oid resume retrieval");
*/

$RETRLINK = "javascript:document.location = '$sendr';";
$RETRLINKJH = "javascript:document.location = '$sendjh';";
$hasjh = strlen($as->getJHFilename());
$ADDSVCSLINK = "addsvc.php?oid=$oid&clid=$clid&i4=$i4&i7=$i7";
$MAILLINK = "../client/emailw.php?oid=$oid&clid=$clid&i4=$i4&i7=$i7";

/*
$f->addButton("Click Here To Download Your Resume",
	"javascript:document.location = '$sendr'");

if (strlen($as->getJHFilename()))
	{
	$f->addButton("Click Here To Download Your Jobhunter file",
		"javascript:document.location = '$sendjh'");
	}

if ($i4)
	{
	$f->addButton("Back To Order Info Screen",
		"javascript:document.location = '../client/oinfo.php?oid=" .
		$or->getID() . "&clid=" . $or->getClid() .
		"&i4=$i4&i7=$i7';");
	}

$f->addInfoRow("Your resume will remain on our web site for 
approximately 30 days. If it is no longer here, please use the
&quot;e-mail&quot; link to have us re-send it to you manually.");

clientPageStart();

echo $f->dumpForm();

clientPageEnd();
*/

require_once("../client/forms/completedresume.php");

exit;

?>