<?php
# $Id: authnet.php 743 2008-09-27 dj $

class authnet
{
	function curl_process($data)
	{

		$authnet_values				= array
		(
			"x_login"				=> $data["login"],
			"x_tran_key"			=> $data["transkey"],
			"x_version"				=> $data["version"],
			"x_delim_char"			=> $data["delimchar"],
			"x_delim_data"			=> $data["delimdata"],
			"x_url"					=> "FALSE",
			"x_type"				=> $data["transtype"],
			"x_method"				=> $data["method"],
 			"x_relay_response"		=> $data["relayresp"],
			"x_test_request"		=> $data["testtrans"],
			"x_amount"				=> $data["chargetotal"],
			"x_card_num"			=> $data["cardnumber"],
			"x_exp_date"			=> $data["cardexpdt"],
			"x_first_name"			=> $data["fname"],
			"x_last_name"			=> $data["lname"],
			"x_address"				=> $data["address"],
			"x_city"				=> $data["city"],
			"x_state"				=> $data["state"],
			"x_zip"					=> $data["zip"],
			"x_country"				=> $data["country"],
			"x_phone"				=> $data["phone"],
			"x_email"				=> $data["email"],
			"x_customer_ip"			=> $data["ip"],
			"x_line_item"			=> $data["lnitem"],
			"x_invoice_num"			=> $data["invno"],
			"x_description"			=> $data["ordesc"],
			"x_trans_id"			=> $data["oid"],
		);

		$fields = "";
		foreach( $authnet_values as $key => $value ) $fields .= "$key=" . urlencode( $value ) . "&";

		$ch = curl_init($data["host"]);
		curl_setopt($ch, CURLOPT_HEADER, 0); 							// set to 0 to eliminate header info from response
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 					// Returns response data instead of TRUE(1)
		curl_setopt($ch, CURLOPT_POSTFIELDS, rtrim( $fields, "& " )); 	// use HTTP POST to send form data
		### curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE); 			// uncomment this line if you get no gateway response. ###

		$resp = curl_exec($ch); //execute post and get results

		curl_close ($ch);

		$tempresult = split('[|]', $resp);

#var_dump($tempresult);
# $tempresult[0] == "3" && $tempresult[2] == "50" || 54
		$result = array();

		if (count($tempresult)!=0) {
			if ($tempresult[0] == "1")
				$result["appr"] = "APPROVED";
			elseif ($tempresult[0] == "2")
				$result["appr"] = "DECLINED";
			elseif ($tempresult[0] == "3")
				$result["appr"] = "ERROR";
			elseif ($tempresult[0] == "4")
				$result["appr"] = "FRAUD";

			$result["errordesc"] = $tempresult[3];
			$result["transid"] = $tempresult[6];
		} else {
			$result["appr"] = "ERROR";
			$result["errordesc"] = "NO VALUE RETURNED";
			$result["transid"] = 0;
		}
		return ($result);
	}
}

?>