<?

# $Id: layout.inc.php 334 2004-03-13 21:22:32Z raf $

/*
CLC 4/14/08 Set up a detector to change the look and feel based on the site this is running as
Use a REQUEST variable to help with the testing as well
*/
global $_SERVER, $_REQUEST, $SiteName;
$SiteName = ""; //Default to blank site name
if ((@preg_match('resumesguaranteed', $_SERVER["HTTP_HOST"])) || (@preg_match('resumesguaranteed', $_REQUEST["server_name"])) ) {
	$SiteName = 'resumesguaranteed';
}


function normalPageStart($funcbody="",$func="")
	{
	global $SiteName;
	require_once("../inc/layout/header.php");
	}

function normalPageEnd()
	{
	require_once("../inc/layout/footer.php");
	}

function writerPageStart()
	{
	global $SiteName;
	require_once("../inc/layout/wheader.php");
	}

function writerPageEnd()
	{
	require_once("../inc/layout/wfooter.php");
	}

function clientPageStart()
	{
	global $SiteName;
	require_once("../inc/layout/cheader.php");
	}

function clientPageEnd()
	{
	require_once("../inc/layout/cfooter.php");
	}

function affiliatePageStart()
	{
	global $SiteName;
	require_once("../inc/layout/aheader.php");
	}

function affiliatePageEnd()
	{
	require_once("../inc/layout/afooter.php");
	}

function tabstart($info="INFO",$tharr=array(),$colspan=1,$nav="",
	$width=LAYOUT_TABLE_WIDTH_DEF)
	{
	echo "<table class=\"tab\" cellspacing=\"0\" width=\"$width\">\n";

	if (strlen($nav))
		tabrownav($nav,$colspan);

	echo "<tr><td colspan=\"$colspan\" class=\"tab-head\"><span
        	class=\"tab-head-txt\">$info</span></td></tr>\n";

	echo "<tr>";

	$i = 0;

	foreach ($tharr as $th)
		{
		echo "<th class=\"tab-th\"";

		if ($i) echo " style=\"border-left: 1px dotted chocolate\"";

		echo "><span class=\"tab-th-txt\">$th</span></td>\n";
		$i++;
		}

	echo "</tr>\n";
	}

function tabrowerr($txt,$colspan=1)
	{
	echo "<tr><td colspan=\"$colspan\" class=\"tab-err\"><span
        class=\"tab-err-txt\">$txt</span></td></tr>";
	}

function tabrowinf($txt,$colspan=1)
	{
	echo "<tr><td colspan=\"$colspan\" class=\"tabinf\"><span
        class=\"tabinftxt\">$txt</span></td></tr>";
	}

function tabrownav($txt,$colspan=1,$top="")
	{
	echo "<tr><td colspan=\"$colspan\" class=\"tabnav$top\"><span
        class=\"tabnavtxt\">$txt</span></td></tr>";
	}

function popup($msg,$fname)
	{
	return "<script language=\"javascript\">
		function $fname()
			{
			alert('$msg');
		//w = window.open('../admin/popup.php?msg=" . 
		urlencode($msg) . "&t=" . time() . "','Popup" . time() . "'," . 
		"'width=" . POPUP_WINDOW_WIDTH .
		",height=" . POPUP_WINDOW_HEIGHT .
		",scrollbars,status=no,toolbar=no,menubar=no,titlebar=0');
			}
		</script>";
	}

?>
