<?

# $Id: orderf-thankyou.php 796 2005-11-28 20:57:43Z raf $

require_once("../inc/autoexec.inc.php");
require_once("../inc/prices.inc.php");

session_name(SESSION_NAME);
session_start();
$_SESSION["finished"] = true;

$site = (isset($_GET["site"]) ? $_GET["site"] : "");
$site = (isset($_POST["site"]) ? $_POST["site"] : $site);
$oid = (isset($_GET["oid"]) ? $_GET["oid"] : 0);
$oid = (isset($_POST["oid"]) ? $_POST["oid"] : $oid);
$ck = (isset($_GET["ck"]) ? $_GET["ck"] : "NOTFOUND");
$ck = (isset($_POST["ck"]) ? $_POST["ck"] : $ck);

if (!$oid) diehard("Order ID# not set");
if (!strlen($site)) diehard("Site not set");
if ($ck != md5("$site Order ID#$$oid"))
	diehard("HACK");

$or = new Order($oid);
if (!$or->wasOK())
	diehard("Order ID#$oid error: " . $or->lastError());

$ot = $or->getOrderType();
$otfilesuffix = $or->descOrderTypeSuffix();
$ORDERTYPEDESC = $or->descOrderTypeName();

$thankyou = sitegfx($site,"thankyou",$otfilesuffix);

$ORDERF_HUNTER = $or->getJobHunter();
$ORDERF_RUSH = $or->getRushID();  // added by Dominik; checking for rush option selected on orderf
$NEXT = "";
$ORDERF_NONCCPAYMENT = $or->hasAltPayment();

$clid = $or->getClid();
$cl = new Client($clid);
if (!$cl->wasOK())
	diehard("Client ID#$clid error: " . $cl->lastError());

$TRACKLINK = $CODEBASE . "/client/";
$TRACKLINK = FixCCLINK($TRACKLINK); //CLC 3/3/09 In resconf.php 
$ORDERF_CPASS = $cl->getPass();

$pr = new Prices();

$prices = $pr->getPrices();
if (!$prices) diehard("getPrices: " . $p->lastError());

foreach ($prices as $n => $v)
	{
	$var = "PRICE_$n";
	$$var = $v[0];
	}

$p = new Settings();
if (!$p->wasOK()) die($p->lastError());
$settings = $p->getSettings();
if (!$settings) die($p->lastError());

foreach ($settings as $n => $v)
	{
	$var = "SETTING_$n";
	$$var = $v[0];
	}

$ORDERF_ORDERID = $oid;
$ORDERF_SITE = $site;
$ORDERF_CK = $ck;

$get = ($_SERVER["REQUEST_METHOD"] == "GET" ? true : false);

$TAF_SLOGAN = "Enter a friend's email address to tell them about our service!";
$senttafs = array();
$TAF_SENT = "";

while (!$get) # do a TAF
	{
	$ta = new TAF();

	$tafmail = (isset($_POST["tafmail"]) ? $_POST["tafmail"] : "");
	if (addslashes($tafmail) != $tafmail)
		diehard("Quotes not allowed in TAF's e-mail");

	$tafs = explode(",",$tafmail);

	if (!strlen($tafmail)) break;

	# weed out bad e-mails

	foreach ($tafs as $k => $v)
		{
		$tafs[$k] = preg_replace("/\s/","",$tafs[$k]);
		if (!$ta->_checkMail($tafs[$k]))
			unset($tafs[$k]);
		else
			{
			$TAF_CLIENT_FIRST = $cl->getFirst();

			$ok = $ta->setMail($tafs[$k]);
			if (!$ok) diehard("Setting TAF: " . $ta->lastError());
			$ok = $ta->setOrderID($oid);
			if (!$ok) diehard("Setting TAF: " . $ta->lastError());
			$ok = $ta->setClid($clid);
			if (!$ok) diehard("Setting TAF: " . $ta->lastError());

			# send the TAF!

			list($msg,$varinfo) = preparemessage(TAF_LETTER);
			if ($msg === false) diehard("TAF letter failed: " .
				$varinfo);
			eval("\$msg = \"" . addslashes($msg) . "\";");
			$msg = stripslashes($msg);

			$to = $ta->getMail();
			$subj = sprintf(TAF_LETTER_SUBJECT,$or->descOrderTypeName());
			list($msg,$headers) = makefilemessage($cl->getMail(),
				$to,$subj,$msg);
			if ($msg === false)
			diehard("Cannot make TAF message: " . $headers);
			$m = mail($to,$subj,$msg,$headers);
			if (!$m) diehard("Cannot set TAF message to '$to'");

			# if sent make a TAF

			$ok = $ta->Update();
			if (!$ok) diehard("Setting TAF: " . $ta->lastError());
#			var_dump($ta);
			$senttafs[] = $ta->getMail();

			# new itteraction

			$ta = new TAF();
			}
		}

	if (count($tafs)) $TAF_SLOGAN = "Tell ANOTHER friend about our service!";
	if (count($senttafs))
		{
		$TAF_SENT = "<table border=\"0\" width=\"100%\"><tr><td
			bgcolor=\"yellow\"><font face=\"Verdana\"><b>Your
			message has been sent successfully to " .
			join(" and ",$senttafs) . ".</b></font></td></tr></table>";
		}
	break;
	}
	
require_once($thankyou);

?>